package commons.pfc;

import java.io.IOException;
import java.io.OutputStreamWriter;

import javax.security.auth.login.LoginException;

import android.app.ProgressDialog;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class login extends AndromediacommonsActivity {
	
	private Button btAccederlogin;
	private ProgressDialog progressBarcredenciales;
	private int progressBarStatus = 0;
 
	
    /** Se llama cuando se crea la interfaz */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
        setContentView(R.layout.layout_login);
        
        inicializar();
    }

    public void inicializar() 
	 {
    	btAccederlogin = (Button) findViewById(R.id.btAcceder_login);
    	btAccederlogin.setOnClickListener(
	                 new OnClickListener() 
	                 {
						   @Override
						   public void onClick(View v) 
						   {
							   String texto = getString(R.string.txt_progressbar_login);
								// preparando el cuadro de dialogo
							   progressBarcredenciales = new ProgressDialog(v.getContext());
							   progressBarcredenciales.setCancelable(true);
							   progressBarcredenciales.setMessage(texto + "...");
							   progressBarcredenciales.setProgressStyle(ProgressDialog.STYLE_SPINNER);
							   progressBarcredenciales.setProgress(0);
							   progressBarcredenciales.setMax(100);
							   progressBarcredenciales.show();
								progressBarStatus = 0;//cuadro de dialogo a 0
								
								new Thread(new Runnable() 
								{
								  public void run() 
								  {
									while (progressBarStatus < 100) 
									{			 
										// Empieza la tarea en segundo plano.
										try { progressBarStatus = Click_Login(); }
										catch (LoginException e1) {// TODO Auto-generated catch block
											e1.printStackTrace(); }
										catch (IOException e1) {// TODO Auto-generated catch block
										e1.printStackTrace(); } catch (Exception e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
									}
									// Imagen subida
									if (progressBarStatus >= 100) 
										progressBarcredenciales.dismiss();
								  }
								}).start();
						  }
	 
	                 });
	 }
    
    
    public void Click_URL(View botton)
    {
    	Intent intent = new Intent();
    	intent.setComponent(new ComponentName(this, llamar_url.class));
    	startActivity(intent);
    }
    /**
     * Se activa cuando se hace click, recoge las credenciales del usuario de la pantalla donde las introdujo
     * las almacena en un fichero y te logea.
     * @param botton click en boton para loguearse la primera vez
     */
    private int Click_Login()throws Exception
    {
    	String credenciales;
    	credenciales = Recoger_Credenciales();
    	datos.credenciales=credenciales.split(",");
    	Intent intent = new Intent();
    	int a = datos.credenciales.length;
    	if(a< 2)//Al menos un caracter para nombre de usuario, otro para password y el separador ','
    	{
    		intent.setComponent(new ComponentName(this, mensaje_campos_obligatorios.class));
    		progressBarcredenciales.dismiss();
    		finish();
    		startActivity(intent);
    	}
    	else
    	{
    		if((a == 2) && (datos.credenciales[0].length() < 1 || datos.credenciales[1].length() < 1))
    		{
    			intent.setComponent(new ComponentName(this, mensaje_campos_obligatorios.class));
        		progressBarcredenciales.dismiss();
        		finish();
        		startActivity(intent);
    			
    		}
    		else
    		{
				usuario.login(datos.credenciales[0], datos.credenciales[1].toCharArray());
		    	
		    	if(usuario.cheked)//usuario.cheked = true;
		    	{
		    		Escribir_Fichero(credenciales);
		    		intent.setComponent(new ComponentName(this, modo_captura.class));
		    		progressBarcredenciales.dismiss();
		    		finish();
		    		startActivity(intent);
		    	}
		    	else
		    	{//Errores de comunicacion con la API
		    		intent.setComponent(new ComponentName(this, errores_api.class));
		    		progressBarcredenciales.dismiss();
		    		finish();
		    		startActivity(intent);
		    		
			    }
    		}
    	}
    	return 100;
    }
    
    /**
     * Pasa los valores de los textview rellenos a variables para poder trabajar desde el cdigo
     * @return Devuelve una terna formada por usuario y contrasea separadas por una coma.
     */
    private String Recoger_Credenciales()
    {
    	TextView username = (TextView) findViewById(R.id.Txtusuario);
    	TextView password = (TextView) findViewById(R.id.Txtpassword);
    	String aux = username.getText().toString() + "," + password.getText().toString();
    	return aux;
    }
    
    /**
     * Recibe los parametro de login del usuario y los almacena en un fichero para su posterior uso.
     * @param credenciales texto con el cual el usuario se logea
     */
    private void Escribir_Fichero(String credenciales)throws Exception
    {
    	try
    	{
    	    OutputStreamWriter fichero=
    	        new OutputStreamWriter(
    	            openFileOutput("credenciales_commons", Context.MODE_WORLD_WRITEABLE));
    	    fichero.write(credenciales);
    	    fichero.close();
    	}
    	catch (Exception ex)
    	{
    	    Log.e("Ficheros", "Error al escribir fichero a memoria interna");
    	}
    }
}