package commons.pfc;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.MyLocationOverlay;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.widget.Toast;


    public class mapa_monumentos extends MapActivity{
        private Vector<String> info_toast = new Vector<String>();
        private MapView mapView;
        private MapController myMapController;
        private List<Overlay> mOverlays;
        private MyLocationOverlay mOverlayLocation;
        private aux x = new aux();//Clase puente para utilizar los datos
     
        @Override
		public void onCreate(Bundle savedInstanceState) {
            super.onCreate(savedInstanceState);
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
            setContentView(R.layout.layout_mapa);
            
            Monumentos_Overlay capas_monumentos = new Monumentos_Overlay(getResources().getDrawable(R.drawable.ico_monumento), this);
            
            mapView = (MapView) findViewById(R.id.mapview);
            myMapController = mapView.getController();
            mOverlays = mapView.getOverlays();
            mOverlayLocation = new MyLocationOverlay(this, mapView);
            
            GeoPoint centro = new GeoPoint((int)(Float.parseFloat(aux.datos.latitud) * 1E6), (int)(Float.parseFloat(aux.datos.longitud) * 1E6));
            myMapController.setCenter(centro);
            myMapController.setZoom(18);
     
            // Sed buenos y meted esto en el onResume, y pararlos en el onPause
            mOverlayLocation.enableMyLocation();
            mOverlayLocation.enableCompass();

            for(int i=0; i < aux.lista_imagenes.size(); ++i)
            	capas_monumentos.addMonumentos(aux.lista_imagenes.get(i).lat.replaceAll("\"", "") + "XXX" + aux.lista_imagenes.get(i).lon.replaceAll("\"", "") + "XXX" + aux.lista_imagenes.get(i).nom_monumento.replaceAll("\"", "") + "XXX" +aux.lista_imagenes.get(i).distancia.replaceAll("\"", ""));
            
            mOverlays.add(mOverlayLocation);
            mOverlays.add(capas_monumentos);
            mapView.postInvalidate();
        }
        
     /*   @Override 
        protected void onPause() {
        	mOverlayLocation.enableMyLocation();
            mOverlayLocation.enableCompass();
        }
        @Override
        protected void onResume() {
        	mOverlayLocation.enableMyLocation();
            mOverlayLocation.enableCompass();
        }
        */
        protected boolean isRouteDisplayed() {
            return false;
        }
        
        public class Monumentos_Overlay extends ItemizedOverlay<OverlayItem> {
            
            private List<OverlayItem> mOverlays;
            private Context mContext;

            public Monumentos_Overlay(Drawable icon, Context context) {
                super(boundCenter(icon));
                mOverlays = new ArrayList<OverlayItem>();
                mContext = context;
            }

            @Override
            protected OverlayItem createItem(int index) {
                return mOverlays.get(index);
            }

            @Override
            public int size() { return mOverlays.size();}

            public void addOverlay(OverlayItem overlay) {
                mOverlays.add(overlay);
                populate();
            }

            public void addMonumentos(String datos_monumento) {
            	String[]monumento = datos_monumento.split("XXX");
                String latt = monumento[0].toString();
                String lonn = monumento[1];
                String nombre = monumento[2];
                String distancia = monumento[3];
                float lat=0, lon=0;
                
                lat = Float.parseFloat(latt);

                lon= Float.parseFloat(lonn);
                GeoPoint point = new GeoPoint((int)(lat * 1E6), (int)(lon * 1E6));
                OverlayItem item_monumento = new OverlayItem(point, "Monumento", nombre);
                addOverlay(item_monumento);
                
                if(distancia.contains("."))
                	distancia = distancia.substring(0, distancia.indexOf("."));
                
                info_toast.add("Monumento: " + nombre + '\n'+ "Distancia: " + distancia + " m");
            }
            
            @Override
            protected final boolean onTap(int index) 
            {
                Toast.makeText(mContext, info_toast.get(index) ,Toast.LENGTH_LONG).show();
                return true;
            }
        }
        
        
        public class aux extends AndromediacommonsActivity
        {
        	//Clase que hace de puente entre AndromediacommonsActivity y mapa monumentos, ya que esta ltima herede de mapactivity y necesito acceder a los datos
        	//de andromedia commonsactivity para ver monumentos y dems datos.
        	//Con esta clase me ahorro de replicar metodos y por lo tanto tambien codigo y el coste de tiempo y consumo de datos asociado a ello,
        }
    }