package commons.pfc;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

import javax.security.auth.login.LoginException;
import android.app.ProgressDialog;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

public class subir extends AndromediacommonsActivity
{
	private Button bt_subirImagen;
	private ProgressDialog progressBar;
	private int progressBarStatus = 0;
	public API_Wiki usuario_subida =null;
 
	 @Override
	    public void onCreate(Bundle savedInstanceState)
	 {
	        super.onCreate(savedInstanceState);
	        setContentView(R.layout.layout_subir);
	        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);//No girar pantalla
	        inicializar();// se queda esperando a la escucha de que se pulse el boton de subir imagen
	 }
	 
	public void inicializar() 
	 {
		 bt_subirImagen = (Button) findViewById(R.id.btsubir);
		 bt_subirImagen.setOnClickListener(
	                 new OnClickListener() 
	                 {
						   @Override
						   public void onClick(View v) 
						   {
							   String texto="";
							   if(!datos.wikimonuments)
									texto = getString(R.string.txt_progressbar_subir);
								else
									texto = getString(R.string.txt_progressbar_subir_monumento);
								// preparando el cuadro de dialogo
								progressBar = new ProgressDialog(v.getContext());
								progressBar.setCancelable(true);
								progressBar.setMessage( texto + "...");
								progressBar.setProgressStyle(ProgressDialog.STYLE_SPINNER);
								progressBar.setProgress(0);
								progressBar.setMax(100);
								progressBar.show();
								progressBarStatus = 0;//cuadro de dialogo a 0
								
								new Thread(new Runnable() 
								{
								  public void run() 
								  {
									while (progressBarStatus < 100) 
									{			 
										// Empieza la tarea en segundo plano.
										try { progressBarStatus = subida_imagen(); }
										catch (LoginException e1) {// TODO Auto-generated catch block
											e1.printStackTrace(); }
										catch (IOException e1) {// TODO Auto-generated catch block
										e1.printStackTrace(); } catch (Exception e) {
											// TODO Auto-generated catch block
											e.printStackTrace();
										}
									}
									// Imagen subida
									if (progressBarStatus >= 100)
										progressBar.dismiss();
								  }
								}).start();

						  }
	 
	                 });
		 
	 }
	 
	// Subida de la imagen, devuelve 100 que es el status del cuadro de dialogo
	public int subida_imagen() throws Exception 
	{
		String contenido ="";
		if(!datos.rafaga)
		{
			File imgFile = new File(datos.path);
			if(datos.subida_manual)//Subida en modo manual
			{
				contenido = Datos_Imagen_Manual();										
				usuario.upload(imgFile, datos.nom_imagen, contenido ,datos.descripcion_corta);
			}
			else
			{
				contenido = Datos_Imagen_Plantilla();
				usuario.upload(imgFile, "subida automatica "+ datos.nom_imagen, contenido ,"");	
			}
			
			if(datos.wikimonuments)
			{
				//Aqui recojo los datos del listView con el monumento concreto q seleccione y monto la estructura que recoja los datos de la pagina concreta,
				//modifique la parte correspondient a ese monumento y vuelva a subir todo lo que pertecence a ese listado
				Actualizar_Listado();
			}
		}
		else
		{
			//String con todo el contenido del fichero de rafga
			String imagenes = Leer_Rafaga();
			//Contenido de la plantilla con los datos de la imagen o rafaga
			contenido = Datos_Imagen_Plantilla();
			
			//Array de Strings con las distintas imaganes de la rafaga y su licencia
			String [] info_imagen = imagenes.split("FFF");
			
			for(int i = 0; i < info_imagen.length-1; ++i)
			{
				//Arrya con el ruta de la imagan y su nombre
				String [] imagenes_licencia = info_imagen[i].split("XXX");
				File imgFile = new File(imagenes_licencia[0]);
				
				if(imgFile.exists())//Evalua si el archivo continua existiendo o se ha borrado
					usuario.upload(imgFile, "subida automatica "+ imagenes_licencia[1], contenido ,"");
			}

		}
	    Siguiente_Layout();
		return 100;
	}
	 
	
	private String Datos_Imagen_Plantilla()
	{
		StringBuilder contenido = new StringBuilder();
		java.util.Date fecha = new Date();
		
		
	    contenido.append("=={{int:filedesc}}==" +'\n');//Descripcin del archivo
	    if(datos.wikimonuments)
	    	contenido.append("{{BIC|" + datos_monumento.BIC.replace("\"", "") + "}}"  + "\n");
	    if((datos.latitud != "" && datos.latitud != "No disponible"))// && (datos.longitud != "" || datos.longitud != "No disponible") && datos.altitud != "")
	    	contenido.append("{{Location dec|" + datos.latitud.replace("\"", "") + "|" + datos.longitud.replace("\"", "") + "|" + datos.altitud.replace("\"", "") + "}}" + '\n');//Localizacin del archivo(latitud-longitud-altitud)
	    contenido.append("{{Information" + '\n');
	    contenido.append("|description={{es|1= Archivo subido de forma automtica, cuando quiera puede modificar la descripcin}}" + '\n'); //Descripcion espaol| 1-> numero de intervenciones = lo que se quiera poner.
	    Calendar c = Calendar.getInstance();
	    contenido.append("|date=" + Integer.toString(c.get(Calendar.YEAR)) + "-"+Integer.toString(c.get(Calendar.MONTH)) +"-" + Integer.toString(c.get(Calendar.DATE)) + '\n');//Fecha
	    contenido.append("|source={{own}}" + '\n');
	    contenido.append("|author=[[User:"+ usuario.getCurrentUser().getUsername().substring(0,1).toUpperCase() + 
	    		usuario.getCurrentUser().getUsername().substring(1, usuario.getCurrentUser().getUsername().length()) +
	    		"|" + usuario.getCurrentUser().getUsername().substring(0,1).toUpperCase() + 
	    		usuario.getCurrentUser().getUsername().substring(1, usuario.getCurrentUser().getUsername().length()) 
	    		+ "]]" + '\n');//Autro de la subida
	    contenido.append("|permission=" + '\n');
	    contenido.append("|other_versions=" + '\n');
	    contenido.append("|other_fields=" + '\n');
	    contenido.append("}}" + '\n');
	    contenido.append("=={{int:license-header}}==" + '\n');//Licencia del archivo
	    if(datos.rafaga)
	    	contenido.append("{{" + datos.licencia + "}}" + '\n');//Tipo de licencia
	    else
	    	contenido.append("{{" + "self|cc-by-sa-3.0" + "}}" + '\n');//Tipo de licencia
	  
	    contenido.append("[[Category:Uploaded with AndromediaCommons]]" + '\n');//Software desde el que se sube el archvo
	    contenido.append("[[Category:" + "Genrica" + "]]");//Categoria
		return contenido.toString();
	}
	
	private String Datos_Imagen_Manual()
	{
		    StringBuilder contenido = new StringBuilder();
		    
		    contenido.append("=={{int:filedesc}}==" +'\n');//Descripcin del archivo
		    if(datos.wikimonuments)
		    	contenido.append("{{BIC|" + datos_monumento.BIC + "}}" + "\n");
		    if((datos.latitud != "" && datos.latitud != "No disponible"))// && (datos.longitud != "" || datos.longitud != "No disponible") && datos.altitud != "")
		    	contenido.append("{{Location dec|" + datos.latitud + "|" + datos.longitud + "|" + datos.altitud + "}}" + '\n');//Localizacin del archivo(latitud-longitud-altitud)
		    contenido.append("{{Information" + '\n');
		    contenido.append("|description={{es|1=" + datos.descripcion + "}}" + '\n'); //Descripcion espaol| 1-> numero de intervenciones = lo que se quiera poner.
		    contenido.append("|date=" + datos.fecha + '\n');//Fecha
		    contenido.append("|source={{own}}" + '\n');
		    contenido.append("|author=[[User:"+ usuario.getCurrentUser().getUsername().substring(0,1).toUpperCase() + 
		    		usuario.getCurrentUser().getUsername().substring(1, usuario.getCurrentUser().getUsername().length()) +
		    		"|" + usuario.getCurrentUser().getUsername().substring(0,1).toUpperCase() + 
		    		usuario.getCurrentUser().getUsername().substring(1, usuario.getCurrentUser().getUsername().length()) 
		    		+ "]]" + '\n');//Autro de la subida
		    contenido.append("|permission=" + '\n');
		    contenido.append("|other_versions=" + '\n');
		    contenido.append("|other_fields=" + '\n');
		    contenido.append("}}" + '\n');
		    contenido.append("=={{int:license-header}}==" + '\n');//Licencia del archivo
		    contenido.append("{{" + datos.licencia + "}}" + '\n');//Tipo de licencia
		    contenido.append("[[Category:Uploaded with AndromediaCommons]]" + '\n');//Software desde el que se sube el archvo
		    if(datos.categoria.length() != 0)
		    	contenido.append("[[Category:" + datos.categoria + "]]");//Categoria
	    	
	 return contenido.toString();
	 }

	private void Siguiente_Layout()
	 {
		
		    Intent intent = new Intent();
		//    if(!datos.wikimonuments)
		  //  {
		    	intent.setComponent(new ComponentName(this, subida_satisfactoria.class));
		    	progressBar.dismiss();
		    	startActivity(intent);
		    //}
		    //else
		   // {//Si puede ser poner el progressBar con otro texto que diga subiendo imagen de monumento
		    	//AQui creare una una una pantala que diga subiendo a wikilove monumente
		    //}
	 }
	 
	public String Leer_Rafaga()throws Exception
    {
    	String texto = "";
    	try
    	{
    	    BufferedReader fichero =
    	        new BufferedReader(
    	            new InputStreamReader(
    	                openFileInput(datos.nombre_rafaga)));
    	    	texto = fichero.readLine();
    	    fichero.close();
    	    
    	  //Una vez subida la rafaga de imagenes pertenecientes a ese archivo se borra.
			File rafaga = new File(datos.path_rafaga + datos.nombre_rafaga);
			rafaga.delete();
				
    	}
    	catch (Exception ex)
    	{
    	    Log.e("Ficheros", "Error al leer fichero desde memoria interna");
    	}
    	return texto;
    }

	private void Get_Datos_Lista(StringBuilder datos_lista) throws IOException
	{
		datos_lista.append(usuario_subida.getPageText(datos_monumento.lista));
	}

	private void Actualizar_Listado() throws IOException, LoginException
	{
		StringBuilder datos_lista = new StringBuilder();
		usuario.logout();
		usuario_subida = new API_Wiki(datos_monumento.dominio);
		usuario_subida.login(datos.credenciales[0], datos.credenciales[1].toCharArray());
		//usuario.domain = datos_monumento.dominio;
		//usuario.initVars();
		Get_Datos_Lista(datos_lista);
		final int long_id = datos_monumento.BIC.replace("\"", "").trim().length();//Longitud del id
		final int i = datos_lista.indexOf(datos_monumento.BIC.replace("\"", "").trim());//Posicion del id en el listado de monumentos
		String x="";//variable auxiliar que sera el trozo de texto que edito
		int seccion=0;//nmero de la seccin que edito
		
		if(datos_monumento.lista.contains("Anexo"))//Si el monumento esta almacenado en un axexo
		{
			//El anexo tiene un campo mas que la lista, la fecha
			if(datos_lista.charAt(i + long_id + 12) == '\n')//la fecha del monumento esta vacia
				datos_lista.insert(i + long_id + 25, datos.nom_imagen);
			else//el momumento contiene fecha distinta de vacio
				datos_lista.insert(i + long_id + 35, datos.nom_imagen);
			
			//datos_lista.insert(i+22, datos.nom_imagen);//inseto el nombre de la foto en el texto
			x = datos_lista.toString();//paso el texto(StringBuilder) a string que es lo que acepta la API
			//esto son pruebas

			String[]monumentos_por_tipo = x.split("==");//Seraro por == para obtener el nombre de los distintos tipos de secciones
			for(int n = 0; n < monumentos_por_tipo.length; ++n)
			{
				//int aux =monumentos_por_tipo[n].indexOf(datos_monumento.BIC.replace("\"", "").trim());
				//Evaluo si el monumento esta en el trozo de texto que hay en la posicion n
				if(monumentos_por_tipo[n].indexOf(datos_monumento.BIC.replace("\"", "").trim()) != -1)// <> -1 esta en el trozo
				{
					seccion=n/2;//div 2 porque el split te divide la seccion en dos partes, por lo tanto para la seccion 2, ocupa los indices 3 y 4,
								//donde en el tres se encuentra en nomnbre de la cabecera o titulo y en la 4 el contenido de dicha seccion
					x= "==" + monumentos_por_tipo[n-1] +"=="+ monumentos_por_tipo[n];//Aado los identificadores que quit con el split
				}
			}
		}
		else
		{//El monumetno esta alojado en un listado
			if(datos.subida_manual)
				datos_lista.insert(i + long_id + 13, datos.nom_imagen);
			else
				datos_lista.insert(i + long_id + 13, "subida automatica " + datos.nom_imagen);
			x = datos_lista.toString();
			
			x = datos_lista.toString();//paso el texto(StringBuilder) a string que es lo que acepta la API
			String[]monumentos_por_tipo = x.split("==");//Seraro por == para obtener el nombre de los distintos tipos de secciones
			for(int n = 0; n < monumentos_por_tipo.length; ++n)
			{
				//int aux =monumentos_por_tipo[n].indexOf(datos_monumento.BIC.replace("\"", "").trim());
				//Evaluo si el monumento esta en el trozo de texto que hay en la posicion n
				if(monumentos_por_tipo[n].indexOf(datos_monumento.BIC.replace("\"", "").trim()) != -1)// <> -1 esta en el trozo
				{
					seccion=n/2;//div 2 porque el split te divide la seccion en dos partes, por lo tanto para la seccion 2, ocupa los indices 3 y 4,
								//donde en el tres se encuentra en nomnbre de la cabecera o titulo y en la 4 el contenido de dicha seccion
					if(n%2 != 0)
						x= "==" + monumentos_por_tipo[n-1] +"=="+ monumentos_por_tipo[n];//Aado los identificadores que quit con el split
					else
						if(n == 0)
						x= monumentos_por_tipo[n];//Aado los identificadores que quit con el split
				}
			}
			
		}
		//hasta aqui*/
		usuario_subida.edit(datos_monumento.lista, x , "", seccion );
	}
    

}
